import 'package:flutter/material.dart';
import 'package:bottom_sheet_stateful/bottom_sheet_stateful.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: 'Maps',
        theme: ThemeData(
          primarySwatch: Colors.blue,
          canvasColor: Colors.transparent,
        ),
        home: IntroPage()
    );
  }
}

class IntroPage extends StatefulWidget {
  @override
  IntroState createState() => IntroState();
}

class IntroState extends State<IntroPage> {
  final GlobalKey<ScaffoldState> _scaffoldKey = GlobalKey<ScaffoldState>();
  final double peekHeight = 100;

  @override
  Widget build(BuildContext context) {
    var headChildWidget = <Widget>[
      Container(
        margin: EdgeInsets.only(bottom: 15),
        width: 100,
        height: 5,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(10.0),
          color: Colors.black12,
        ),
      ),
    ];

    var bodyWidget = <Widget>[
      Padding(
        padding: EdgeInsets.only(top: 100),
        child: Text('Login',
            maxLines: 1,
            overflow: TextOverflow.ellipsis,
            style: TextStyle(
                fontFamily: "GTWalsheim-Medium",
                fontSize: 30.0,
                color: Colors.black
            )
        ),
      )
    ];

    var bsCallback = (double height) {
      print(height);
      if (height==peekHeight) {
        const iconUp = "assets/icons/ic_up.png";
        const iconDown = "assets/icons/ic_down.png";
        headChildWidget.add(Image.asset((height==peekHeight) ? iconUp : iconDown, scale: 1.0, width: 25, height: 25))
        headChildWidget.add(Padding(
            padding: EdgeInsets.all(15),
            child: Text("Swipe up to start", style: TextStyle(fontSize: 11))
        ));
      }
    };

    return Scaffold(
      key: _scaffoldKey,
      body: Container(
          decoration: BoxDecoration(
            image: DecorationImage(
              image: AssetImage("assets/images/bg.png"),
              fit: BoxFit.cover,
            ),
          ),
          child: BottomSheetStateful(
            Center(child: Column(children: headChildWidget)), //headWidget
            Column(children: bodyWidget), //bodyWidget
            peekHeight, //peekHeight
            0, //marginTop
            17, //topRadius
            bsCallback
          ),
      ),
    );
  }
}